<template>
  <v-alert
      v-if="success"
      type="success"
      closable
      title="สมัครสมาชิกเสร็จสิ้น"
      text="กรุณาตรวจสอบกล่องจดหมายในอีเมลของท่าน"
  />
  <v-alert
      v-if="warning"
      type="warning"
      closable
      title="ชื่อผู้ใช้หรืออีเมลถูกใช้งานแล้ว"
  />
  <v-alert
      v-if="warningSid"
      type="warning"
      closable
      title="รหัสนักศึกษานี้ถูกใช้งานแล้ว"
  />
  <div class="container">
    <v-card class="card">
      <div class="lo-icon">
        <v-btn variant="text" icon="mdi-arrow-left" to="/login"></v-btn>
      </div>

      <h2>สมัครสมาชิก</h2>
      <v-form @submit.prevent="onRegister" class="form">
        <v-text-field
            v-model="username"
            :rules="[usernameRules.required]"
            label="ชื่อผู้ใช้"
            placeholder="Username"
            variant="solo"
            rounded="xl"
            density="comfortable"
            clearable
        ></v-text-field>
        <v-text-field
            v-model="password"
            v-if="isLoaded"
            :rules="[passwordRules.required, passwordRules.min]"
            :type="visible1 ? 'text' : 'password'"
            :append-inner-icon="visible1 ? 'mdi-eye-off' : 'mdi-eye'"
            @click:append-inner="visible1 = !visible1"
            label="รหัสผ่าน"
            placeholder="Password"
            variant="solo"
            rounded="xl"
            density="comfortable"
            counter
            clearable
        ></v-text-field>
        <v-text-field
            v-model="cpassword"
            v-if="isLoaded"
            :rules="[
            passwordRules.required,
            passwordRules.min,
            passwordRules.match,
          ]"
            :type="visible2 ? 'text' : 'password'"
            :append-inner-icon="visible2 ? 'mdi-eye-off' : 'mdi-eye'"
            @click:append-inner="visible2 = !visible2"
            label="ยืนยัน-รหัสผ่าน"
            placeholder="Confirm Password"
            variant="solo"
            rounded="xl"
            density="comfortable"
            counter
            clearable
        ></v-text-field>
        <v-text-field
            v-model="email"
            :rules="[emailRules.required, emailRules.check]"
            label="อีเมล"
            placeholder="Email"
            variant="solo"
            rounded="xl"
            density="comfortable"
            type="email"
            clearable
        ></v-text-field>

        <br/>
        <v-select
            v-model="department"
            :items="departments"
            :rules="[depRules.required]"
            label="สาขา"
            variant="solo"
            rounded="xl"
            density="comfortable"
            item-title="attributes.name"
            item-value="id"
        >
          <template v-slot:item="{ props }">
            <v-list-item v-bind="props" rounded="xl"></v-list-item>
          </template>
        </v-select>
        <v-text-field
            v-model="studentid"
            :rules="[sidRules.required, sidRules.format]"
            label="รหัสนักศึกษา"
            placeholder="Student ID"
            variant="solo"
            rounded="xl"
            density="comfortable"
            clearable
        ></v-text-field>

        <br/>
        <v-select
            v-model="prefix"
            :items="['นาย', 'นางสาว']"
            :rules="[prefixRules.required]"
            label="คำนำหน้า"
            variant="solo"
            rounded="xl"
            density="comfortable"
            item-title="attributes.name"
            item-value="id"
        >
          <template v-slot:item="{ props }">
            <v-list-item v-bind="props" rounded="xl"></v-list-item>
          </template>
        </v-select>
        <v-text-field
            v-model="firstname"
            :rules="[firstnameRules.required]"
            label="ชื่อ"
            placeholder="First Name"
            variant="solo"
            rounded="xl"
            density="comfortable"
            clearable
        ></v-text-field>
        <v-text-field
            v-model="lastname"
            :rules="[lastnameRules.required]"
            label="นามสกุล"
            placeholder="Last Name"
            variant="solo"
            rounded="xl"
            density="comfortable"
            clearable
        ></v-text-field>
        <v-text-field
            v-model="phonenumber"
            v-if="isLoaded"
            :rules="[phonenumberRules.required]"
            label="เบอร์โทรศัพท์"
            placeholder="Phone Number"
            variant="solo"
            rounded="xl"
            density="comfortable"
            counter="10"
            clearable
        ></v-text-field>

        <v-btn
            :loading="loadingbtn"
            :disabled="!isFormValid"
            type="submit"
            block
            class="submit-btn"
            size="large"
            variant="flat"
            rounded="xl"
        >ยืนยัน
        </v-btn>
      </v-form>
    </v-card>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | สมัครสมาชิก",
  meta: [{name: "description", content: "ระบบยืม-คืนอุปกรณ์สาขาวิชา"}],
});
// ปิด layout
definePageMeta({
  layout: false,
});

import {ref} from "vue";
import axios from "axios";

const {register, sendEmailConfirmation} = useStrapiAuth()
const router = useRouter()
const url = useStrapiUrl()

const username = ref()
const password = ref()
const cpassword = ref()
const email = ref()
const department = ref()
const prefix = ref()
const studentid = ref()
const firstname = ref()
const lastname = ref()
const phonenumber = ref()

const success = ref(false)
const warning = ref(false)
const warningSid = ref(false)

const visible1 = ref(false)
const visible2 = ref(false)

const loadingbtn = ref(false)
const isLoaded = ref(false)
const departments = ref([])

// กฎในการกรอกข้อมูล
const usernameRules = {
  required: (value) => !!value || "กรุณากรอกชื่อผู้ใช้",
};
const passwordRules = {
  required: (value) => !!value || "กรุณากรอกรหัสผ่าน",
  min: (v) => v.length >= 8 || "อย่างน้อย 8 ตัวอักษร",
  match: () => cpassword.value === password.value || "รหัสผ่านไม่ตรงกัน",
};
const emailRules = {
  required: (value) => !!value || "กรุณากรอกที่อยู่อีเมล",
  check: (value) => {
    const pattern = /^[^\s@]+@[^\s@]+\.[^\s@]+$/; // Regular expression pattern for basic email format
    const domain = "@rmuti.ac.th";
    if (!value) return true; // Return true if the value is empty, because it's not required
    if (!pattern.test(value)) return "รูปแบบอีเมลไม่ถูกต้อง"; // Check if the email format is valid
    if (!value.endsWith(domain)) return `ที่อยู่อีเมลต้องเป็น @rmuti.ac.th`; // Check if the email ends with "@rmuti.ac.th"
    return true; // Return true if all checks pass
  },
};
const depRules = {
  required: (value) => !!value || "กรุณาเลือกสาขาวิชา",
};
const sidRules = {
  required: (value) => !!value || "กรุณากรอกรหัสนักศึกษา",
  format: (value) => {
    const pattern = /^\d{11,}-\d$/;
    return pattern.test(value) || "รูปแบบไม่ถูกต้อง เช่น xxxxxxxxxxx-x";
  },
};
const prefixRules = {
  required: (value) => !!value || "กรุณาเลือกคำนำหน้า",
};
const firstnameRules = {
  required: (value) => !!value || "กรุณากรอกชื่อ",
};
const lastnameRules = {
  required: (value) => !!value || "กรุณากรอกนามสกุล",
};
const phonenumberRules = {
  required: (value) => !!value || "กรุณากรอกเบอร์โทรศัพท์มือถือ",
};
// ตรวจสอบเงื่อนไขก่อน submit
const isFormValid = computed(() => {
  return (
      !!username.value &&
      !!password.value &&
      !!cpassword.value &&
      !!email.value &&
      !!department.value &&
      !!studentid.value &&
      !!firstname.value &&
      !!lastname.value &&
      !!phonenumber.value &&
      isstudentidValid(studentid.value) &&
      isemailValid(email.value) &&
      ispasswordValid(password.value, cpassword.value) &&
      isphonenumberValid(phonenumber.value)
  );
});
const isemailValid = (value) => value && value.endsWith("@rmuti.ac.th");
const isphonenumberValid = (value) =>
    value && value.startsWith("0") && value.length === 10 && !isNaN(value);
const ispasswordValid = (password, cpassword) => {
  const isLengthValid = password.length >= 8;
  const isMatchValid = password === cpassword;
  return isLengthValid && isMatchValid;
};
const isstudentidValid = (value) => {
  // เช็คว่ามี "-" และตัวเลขลงท้ายหรือไม่
  const pattern = /^\d+-\d$/;
  return pattern.test(value) && value.length >= 13;
};

// กด submit
const onRegister = async () => {
  loadingbtn.value = true;
  setTimeout(() => (loadingbtn.value = false), 2000);

  try {
    await register({
      username: username.value,
      email: email.value,
      password: password.value,
      department: department.value,
      prefix: prefix.value,
      firstname: firstname.value,
      lastname: lastname.value,
      student_id: studentid.value,
      phone_number: phonenumber.value,

    }).then(async (response) => {
      console.log("Created User");
      window.scrollTo({ top: 0, behavior: 'smooth' });
      success.value = true;
      await new Promise(resolve => setTimeout(resolve, 5000));
      success.value = false;

      router.push('/login')
    });
  } catch (error) {
    console.log(error.error.message);
    if(error.error.message === "Email or Username are already taken") {
      warning.value = true;
      await new Promise(resolve => setTimeout(resolve, 5000));
      warning.value = false;
    }
    if(error.error.message === "This attribute must be unique") {
      warningSid.value = true;
      await new Promise(resolve => setTimeout(resolve, 5000));
      warningSid.value = false;
    }
  }
};

async function getDepartments() {
  await axios.get(`${url}/departments?sort[0]=id:asc&fields=name`).then((res) => {
    departments.value = [...res.data.data];
  });
}
console.log("Departments :", departments)

onMounted(async () => {
  isLoaded.value = true;
  getDepartments();
});
</script>

<style scoped>
@import url(../assets/css/styles/register.css);
</style>
